﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'Custom View class
#Event: Changed (oldValue As Double,newValue As Double)
#DesignerProperty: Key: Vertical, DisplayName: Mark for vertical, FieldType: Boolean, DefaultValue: False, Description: Wheter it is vertical or horizontal.
#DesignerProperty: Key: Indicator, DisplayName: Mark for right, FieldType: Boolean, DefaultValue: False, Description: Wheter it is left or right.
#DesignerProperty: Key: minValue, DisplayName: minValue, FieldType: Int, DefaultValue: 0, Description: minValue.
#DesignerProperty: Key: maxValue, DisplayName: maxValue, FieldType: Int, DefaultValue: 100, Description: maxValue.
'#DesignerProperty: Key: BlockIncrement, DisplayName: BlockIncrement, FieldType: Int, DefaultValue: 1, Description: blocks.
#DesignerProperty: Key: Value, DisplayName: Value, FieldType: Int, DefaultValue: 0, Description: Value.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	
	Private sliderObj As JavaObject
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	sliderObj.InitializeNewInstance("com.jfoenix.controls.JFXSlider",Null)
	
	Dim ev As Object = sliderObj.RunMethodjo("valueProperty",Null).CreateEventFromUI("javafx.beans.value.ChangeListener","oc",Null)
	sliderObj.RunMethodjo("valueProperty",Null).RunMethod("addListener",Array(ev))
End Sub

private Sub oc_Event (MethodName As String, Args() As Object) As Object
	If SubExists(mCallBack,mEventName & "_changed") Then
		CallSubDelayed3(mCallBack,mEventName & "_changed",Args(1),Args(2))
	End If
	
	Return True
End Sub

public Sub setMinimum(value As Double)
	sliderObj.RunMethod("setMin",Array(value))
End Sub

public Sub getMinimum As Double
	Return sliderObj.RunMethod("getMin",Null)
End Sub

public Sub setMaximum(Value As Double)
	sliderObj.RunMethod("setMax",Array(Value))
End Sub

public Sub getMaximum As Double
	Return sliderObj.RunMethod("getMax",Null)
End Sub

public Sub setValue(Value As Double)
	sliderObj.RunMethod("setValue",Array(Value))
End Sub

public Sub getValue As Double
	Return sliderObj.RunMethod("getValue",Null)
End Sub

'HORIZONTAL
'VERTICAL
public Sub setOrientation(value As String)
	sliderObj.RunMethod("setOrientation",Array(value))
End Sub

'LEFT
'RIGHT
public Sub setIndicatorPosition(pos As String)
	sliderObj.RunMethod("setIndicatorPosition",Array(pos))
End Sub

'public Sub setBlockIncrement(value As Double)
'	sliderObj.RunMethod("setBlockIncrement",Array(value))
'End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	mBase.AddNode(sliderObj,0,0,Base.PrefWidth,Base.PrefHeight)		
	
	setMinimum(Props.GetDefault("minValue",0))
	setMaximum(Props.GetDefault("maxValue",100))
	setValue(Props.GetDefault("Value",0))
	
	If Not(Props.GetDefault("Vertical",False)) Then
		setOrientation("HORIZONTAL")
	Else
		setOrientation("VERTICAL")
	End If
	
	If Not(Props.GetDefault("Indicator",False)) Then
		setIndicatorPosition("LEFT")
	Else
		setIndicatorPosition("RIGHT")
	End If
	
'	setBlockIncrement(Props.GetDefault("BlockIncrement",1))
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mBase.GetNode(0).PrefWidth = Width
	mBase.GetNode(0).PrefHeight = Height
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub








